                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*version 3: factored out environment*/
                     /*-----------------------------------*/
                     /*               memory              */
                     /*-----------------------------------*/

#include "SlipMain.h"

/*------------------------------ private constants ---------------------------*/

static const TXT_type IMM_error_string = "insufficient memory";

static const UNS_type Size_max = 0x00FFFFFF;
static const CEL_type Tag_mask = 0x000000FF;
static const BYT_type PTR_size = sizeof(PTR_type);

enum { Size_Shift = 8 };

/*------------------------------ private variables ---------------------------*/

static PTR_type Free_pointer;
static PTR_type Head_pointer;
static PTR_type Tail_pointer;

/*------------------------------ private functions ---------------------------*/

static CEL_type make_header(BYT_type Tag,
                            UNS_type Siz)
  { return (Siz << Size_Shift) | Tag; }

/*------------------------------ public functions ----------------------------*/

UNS_type Memory_Get_Size(PTR_type Pointer)
  { return Pointer->cel >> Size_Shift; }

BYT_type Memory_Get_Tag(PTR_type Pointer)
  { return (Pointer->cel & Tag_mask); }

NIL_type Memory_Initialize(ADR_type Address,
                           UNS_type Size   )
  { Head_pointer = (PTR_type)Address;
    Free_pointer = Head_pointer + 1;
    Tail_pointer = Head_pointer + Size; }

PTR_type Memory_Make_Chunk(BYT_type Tag ,
                           UNS_type Size)
  { PTR_type pointer;
    pointer = Free_pointer;
    Free_pointer->cel = make_header(Tag,
                                    Size);
    Free_pointer += Size + 1;
    if (Free_pointer >= Tail_pointer)
      Main_Fatal_Error(IMM_error_string);
    return pointer; }
